<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!-- NewPage -->
<html lang="en">
<head>
<!-- Generated by javadoc (version 1.7.0_80) on Wed Sep 20 14:52:14 UTC 2017 -->
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<title>DependencySubstitutions (Gradle API 4.2)</title>
<meta name="date" content="2017-09-20">
<link rel="stylesheet" type="text/css" href="../../../../javadoc.css" title="Style">
</head>
<body>
<script type="text/javascript"><!--
    if (location.href.indexOf('is-external=true') == -1) {
        parent.document.title="DependencySubstitutions (Gradle API 4.2)";
    }
//-->
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a name="navbar_top">
<!--   -->
</a><a href="#skip-navbar_top" title="Skip navigation links"></a><a name="navbar_top_firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../index-all.html">Index</a></li>
<li><a href="../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../../../org/gradle/api/artifacts/DependencySubstitution.html" title="interface in org.gradle.api.artifacts"><span class="strong">Prev Class</span></a></li>
<li><a href="../../../../org/gradle/api/artifacts/DependencySubstitutions.Substitution.html" title="interface in org.gradle.api.artifacts"><span class="strong">Next Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../../../index.html?org/gradle/api/artifacts/DependencySubstitutions.html" target="_top">Frames</a></li>
<li><a href="DependencySubstitutions.html" target="_top">No Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_top">
<li><a href="../../../../allclasses-noframe.html">All Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li><a href="#nested_class_summary">Nested</a>&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method_summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method_detail">Method</a></li>
</ul>
</div>
<a name="skip-navbar_top">
<!--   -->
</a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
<!-- ======== START OF CLASS DATA ======== -->
<div class="header">
<div class="subTitle">org.gradle.api.artifacts</div>
<h2 title="Interface DependencySubstitutions" class="title">Interface DependencySubstitutions</h2>
</div>
<div class="contentContainer">
<div class="description">
<ul class="blockList">
<li class="blockList">
<hr>
<br>
<pre><a href="../../../../org/gradle/api/Incubating.html" title="annotation in org.gradle.api">@Incubating</a>
public interface <span class="strong">DependencySubstitutions</span></pre>
<div class="block">Allows replacing dependencies with other dependencies.</div>
<dl><dt><span class="strong">Since:</span></dt>
  <dd>2.5</dd></dl>
</li>
</ul>
</div>
<div class="summary">
<ul class="blockList">
<li class="blockList">
<!-- ======== NESTED CLASS SUMMARY ======== -->
<ul class="blockList">
<li class="blockList"><a name="nested_class_summary">
<!--   -->
</a>
<h3>Nested Class Summary</h3>
<table class="overviewSummary" border="0" cellpadding="3" cellspacing="0" summary="Nested Class Summary table, listing nested classes, and an explanation">
<caption><span>Nested Classes</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Interface and Description</th>
</tr>
<tr class="altColor">
<td class="colFirst"><code>static interface&nbsp;</code></td>
<td class="colLast"><code><strong><a href="../../../../org/gradle/api/artifacts/DependencySubstitutions.Substitution.html" title="interface in org.gradle.api.artifacts">DependencySubstitutions.Substitution</a></strong></code>
<div class="block">Provides a DSL-friendly mechanism for specifying the target of a substitution.</div>
</td>
</tr>
</table>
</li>
</ul>
<!-- ========== METHOD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="method_summary">
<!--   -->
</a>
<h3>Method Summary</h3>
<table class="overviewSummary" border="0" cellpadding="3" cellspacing="0" summary="Method Summary table, listing methods, and an explanation">
<caption><span>Methods</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Method and Description</th>
</tr>
<tr class="altColor">
<td class="colFirst"><code><a href="../../../../org/gradle/api/artifacts/DependencySubstitutions.html" title="interface in org.gradle.api.artifacts">DependencySubstitutions</a></code></td>
<td class="colLast"><code><strong><a href="../../../../org/gradle/api/artifacts/DependencySubstitutions.html#all(org.gradle.api.Action)">all</a></strong>(<a href="../../../../org/gradle/api/Action.html" title="interface in org.gradle.api">Action</a>&lt;? super <a href="../../../../org/gradle/api/artifacts/DependencySubstitution.html" title="interface in org.gradle.api.artifacts">DependencySubstitution</a>&gt;&nbsp;rule)</code>
<div class="block">Adds a dependency substitution rule that is triggered for every dependency (including transitive)
 when the configuration is being resolved.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code><a href="../../../../org/gradle/api/artifacts/component/ComponentSelector.html" title="interface in org.gradle.api.artifacts.component">ComponentSelector</a></code></td>
<td class="colLast"><code><strong><a href="../../../../org/gradle/api/artifacts/DependencySubstitutions.html#module(java.lang.String)">module</a></strong>(<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;notation)</code>
<div class="block">Create a ModuleComponentSelector from the provided input string.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code><a href="../../../../org/gradle/api/artifacts/component/ComponentSelector.html" title="interface in org.gradle.api.artifacts.component">ComponentSelector</a></code></td>
<td class="colLast"><code><strong><a href="../../../../org/gradle/api/artifacts/DependencySubstitutions.html#project(java.lang.String)">project</a></strong>(<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;path)</code>
<div class="block">Create a ProjectComponentSelector from the provided input string.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code><a href="../../../../org/gradle/api/artifacts/DependencySubstitutions.Substitution.html" title="interface in org.gradle.api.artifacts">DependencySubstitutions.Substitution</a></code></td>
<td class="colLast"><code><strong><a href="../../../../org/gradle/api/artifacts/DependencySubstitutions.html#substitute(org.gradle.api.artifacts.component.ComponentSelector)">substitute</a></strong>(<a href="../../../../org/gradle/api/artifacts/component/ComponentSelector.html" title="interface in org.gradle.api.artifacts.component">ComponentSelector</a>&nbsp;substitutedDependency)</code>
<div class="block">DSL-friendly mechanism to construct a dependency substitution for dependencies matching the provided selector.</div>
</td>
</tr>
</table>
</li>
</ul>
</li>
</ul>
</div>
<div class="details">
<ul class="blockList">
<li class="blockList">
<!-- ============ METHOD DETAIL ========== -->
<ul class="blockList">
<li class="blockList"><a name="method_detail">
<!--   -->
</a>
<h3>Method Detail</h3>
<a name="all(org.gradle.api.Action)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>all</h4>
<pre><a href="../../../../org/gradle/api/artifacts/DependencySubstitutions.html" title="interface in org.gradle.api.artifacts">DependencySubstitutions</a>&nbsp;all(<a href="../../../../org/gradle/api/Action.html" title="interface in org.gradle.api">Action</a>&lt;? super <a href="../../../../org/gradle/api/artifacts/DependencySubstitution.html" title="interface in org.gradle.api.artifacts">DependencySubstitution</a>&gt;&nbsp;rule)</pre>
<div class="block">Adds a dependency substitution rule that is triggered for every dependency (including transitive)
 when the configuration is being resolved. The action receives an instance of <a href="../../../../org/gradle/api/artifacts/DependencySubstitution.html" title="interface in org.gradle.api.artifacts"><code>DependencySubstitution</code></a>
 that can be used to find out what dependency is being resolved and to influence the resolution process.
 <p>
 Example:
 <pre class='autoTested'>
 configurations { main }
 // add dependency substitution rules
 configurations.main.resolutionStrategy.dependencySubstitution {
   // Use a rule to change the dependency module while leaving group + version intact
   all { DependencySubstitution dependency -&gt;
     if (dependency.requested instanceof ModuleComponentSelector &amp;&amp; dependency.requested.name == 'groovy-all') {
       dependency.useTarget details.requested.group + ':groovy:' + details.requested.version
     }
   }
   // Use a rule to replace all missing projects with module dependencies
   all { DependencySubstitution dependency -&gt;
    if (dependency.requested instanceof ProjectComponentSelector) {
       def targetProject = findProject(":${dependency.requested.path}")
       if (targetProject == null) {
         dependency.useTarget "org.myorg:" + dependency.requested.path + ":+"
       }
     }
   }
 }
 </pre>

 The rules are evaluated in order they are declared. Rules are evaluated after forced modules are applied (see <a href="../../../../org/gradle/api/artifacts/ResolutionStrategy.html#force(java.lang.Object...)"><code>ResolutionStrategy.force(Object...)</code></a></div>
<dl><dt><span class="strong">Returns:</span></dt><dd>this</dd></dl>
</li>
</ul>
<a name="module(java.lang.String)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>module</h4>
<pre><a href="../../../../org/gradle/api/artifacts/component/ComponentSelector.html" title="interface in org.gradle.api.artifacts.component">ComponentSelector</a>&nbsp;module(<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;notation)</pre>
<div class="block">Create a ModuleComponentSelector from the provided input string. Strings must be in the format "{group}:{module}:{version}".</div>
</li>
</ul>
<a name="project(java.lang.String)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>project</h4>
<pre><a href="../../../../org/gradle/api/artifacts/component/ComponentSelector.html" title="interface in org.gradle.api.artifacts.component">ComponentSelector</a>&nbsp;project(<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;path)</pre>
<div class="block">Create a ProjectComponentSelector from the provided input string. Strings must be in the format ":path".</div>
</li>
</ul>
<a name="substitute(org.gradle.api.artifacts.component.ComponentSelector)">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>substitute</h4>
<pre><a href="../../../../org/gradle/api/artifacts/DependencySubstitutions.Substitution.html" title="interface in org.gradle.api.artifacts">DependencySubstitutions.Substitution</a>&nbsp;substitute(<a href="../../../../org/gradle/api/artifacts/component/ComponentSelector.html" title="interface in org.gradle.api.artifacts.component">ComponentSelector</a>&nbsp;substitutedDependency)</pre>
<div class="block">DSL-friendly mechanism to construct a dependency substitution for dependencies matching the provided selector.
 <p>
 Examples:
 <pre class='autoTested'>
 configurations { main }
 configurations.main.resolutionStrategy.dependencySubstitution {
   // Substitute project and module dependencies
   substitute module('org.gradle:api') with project(':api')
   substitute project(':util') with module('org.gradle:util:3.0')

   // Substitute one module dependency for another
   substitute module('org.gradle:api:2.0') with module('org.gradle:api:2.1')
 }
 </pre></div>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
</div>
<!-- ========= END OF CLASS DATA ========= -->
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a name="navbar_bottom">
<!--   -->
</a><a href="#skip-navbar_bottom" title="Skip navigation links"></a><a name="navbar_bottom_firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../index-all.html">Index</a></li>
<li><a href="../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../../../org/gradle/api/artifacts/DependencySubstitution.html" title="interface in org.gradle.api.artifacts"><span class="strong">Prev Class</span></a></li>
<li><a href="../../../../org/gradle/api/artifacts/DependencySubstitutions.Substitution.html" title="interface in org.gradle.api.artifacts"><span class="strong">Next Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../../../index.html?org/gradle/api/artifacts/DependencySubstitutions.html" target="_top">Frames</a></li>
<li><a href="DependencySubstitutions.html" target="_top">No Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_bottom">
<li><a href="../../../../allclasses-noframe.html">All Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li><a href="#nested_class_summary">Nested</a>&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method_summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method_detail">Method</a></li>
</ul>
</div>
<a name="skip-navbar_bottom">
<!--   -->
</a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
</body>
</html>
